# unpack fused gtest sources

# MST_GTEST
#----------
AC_DEFUN([MST_GTEST],
[
AC_ARG_WITH( [gtest],
             [AS_HELP_STRING([--with-gtest=ARG],
                             [ARG is path to googletest archive @<:@default=use bundled version@:>@])],
             [],[with_gtest=no]
           )
if test "$with_gtest" = "" ; then

    AC_MSG_ERROR([--with-gtest requires an argument])

elif test "$with_gtest" = no ; then

    AC_CHECK_FILE([$srcdir/tests/gtest/gtest-all.cc],
                  [],
                  [AC_CHECK_FILE([tests/gtest/gtest-all.cc],
                                 [],
                                 [AC_MSG_ERROR([googletest is not bundled; please specify it with --with-gtest])]
                                 )
                  ]
                 )
    AC_MSG_NOTICE([using bundled googletest])
else

    AC_MSG_NOTICE([trying googletest distribution $with_gtest])
    AC_CHECK_FILE([$with_gtest],
                  [],
                  [AC_MSG_ERROR(cannot find $with_gtest)]
                 )
    AS_CASE( [$with_gtest],
            [*.zip],
            [
                AC_PATH_PROG([UNZIP],[unzip],[no])
                test "$UNZIP" = no && \
                    AC_MSG_ERROR([unzip not found; unable to extract googletest])
                AC_MSG_NOTICE([unpacking $with_gtest])
                AS_MKDIR_P([tests/gtest])
                gbase=`echo /$with_gtest | sed 's:^.*/\(.*\).zip:\1:'`
                unzip -o -j -q \
                    $with_gtest "$gbase/fused-src/gtest*" $gbase/COPYING \
                    -d tests/gtest || \
                    AC_MSG_ERROR([error extracting googletest])
            ],
            [
                AC_MSG_ERROR([do not know how to unpack googletest archive $with_gtest])
            ]
            )

fi

# googletest uses variadic macros, which g++ -pedantic-errors is very unhappy about
AC_SUBST([GTEST_CXXFLAGS],
        [`AS_ECHO_N(["$CXXFLAGS"]) | sed s/-pedantic-errors/-pedantic/`]
        )
])
